Attribute VB_Name = "modMain"
        '- - - - - - - - - - - - - - - - - - - - - - - - - - - - '
        ' Hyperwrite from NIXON                                  '
        ' Copyright (C) 2004-2006 NIXON Software Corporation.    '
        '- - - - - - - - - - - - - - - - - - - - - - - - - - - - '
        ' You may use this code freely in your own applications. '
        ' If you are distributing your code/application(s), it   '
        ' would be greatly appreciated if you credit NIXON in    '
        ' your About dialog. Please note that portions of this   '
        ' code belongs to other people. For more details, please '
        ' view the About dialog.                                 '
        '- - - - - - - - - - - - - - - - - - - - - - - - - - - - '
Option Explicit
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function LockWindowUpdate Lib "user32" (ByVal hwnd As Long) As Long
Public fMainForm As frmMain
Public Const sApostrophe = ""
Public Const WM_CLEAR = &H303
Public Const WM_COPY = &H301
Public Const WM_CUT = &H300E
Public Const WM_PASTE = &H302
Public Const EM_GETLINECOUNT = &HBA

Public bNormal As Boolean
Public bRandomizeColor As Boolean
Public bRealSymbols As Boolean
Public bReplaceAll As Boolean
Public bRubberBand As Boolean
Public bSaveAsYouType As Boolean
Public bUserSelected As Boolean
Public intMsgReturn As Integer
Public lDocumentCount As Long
Public lRightMargin As Long
Public lSaveStart As Long
Public sFileName As String



Sub Main()
    frmSplash.Show
    frmSplash.Refresh
    Set fMainForm = New frmMain
Load fMainForm
Unload frmSplash
bRealSymbols = True
End Sub
Public Function GetLineCount(Control_hWnd As Long) As Long
On Error GoTo 10
    GetLineCount = SendMessage(Control_hWnd, EM_GETLINECOUNT, True, 0&)
10:
End Function

Public Sub ErrorTrap(sFile As String)
If Err.Number = 0 Then Exit Sub
fMainForm.sbStatusBar.Panels(1).text = "Error"
    Select Case Err.Number
    Case 53
    If sFile = "" Then
        CustomBox "Error 53: File not found", "Your file was not found. Please check on the spelling. The file may have been moved, renamed, or deleted.", vbCritical, "", "", "OK"
    Else
        CustomBox "The file " & ParseFileName(sFile) & " could not be found.", "Please check on the spelling. The file may have been moved, renamed, or deleted.", vbCritical, "", "", "OK"
    End If
    Case 61
    CustomBox "Error 61: Disk full", "The media youre trying to write to is full. Please delete unnecessary files on the media before saving.", vbCritical, "", "", "OK"
    Case 71
    CustomBox "Error 71: Media not ready", "Check if the drive door/tray is open and the disk is inside the drive.", vbCritical, "", "", "OK"
    Case 72
    CustomBox "Error 72: File I/O error.", "The file you were trying to view or modify could be damaged. Please contact your system administrator for assistance.", vbCritical, "", "", "OK"
    Case 75
    CustomBox "Error 75: File/Path cannot be accessed or is invalid.", "This can happen if the file is read-only. To make the file writable, go to File > Get Info, uncheck the Read-Only check box and then click Apply Attributes.", vbCritical, "", "", "OK"
    Case 57
    CustomBox "Error 57: Device I/O error.", "There is a problem with the device you were trying to save to. Please contact your system administrator for assistance.", vbCritical, "", "", "OK"
    Case Else
    CustomBox "An error has occured.", Err.Number & ": " & Err.Description, vbCritical, "", "", "OK"
    End Select
fMainForm.sbStatusBar.Panels(1).text = "Ready"
End Sub

Public Function SelectLine(rtfTheRtf As RichTextBox, lngLine As Long) As Boolean
If fMainForm.ActiveForm Is Nothing Then Exit Function
  Dim lngPos As Integer, lngLineCount As Long, blnFound As Boolean
  Dim blnEnd As Boolean, lngLineStart As Long
  'Start at beginning of text
  rtfTheRtf.SelStart = 0
   
  lngLineCount = 0
  blnFound = False
  lngPos = 0
  blnEnd = False
  'Go through the text until we find the right line or we hit the end of the
  'text or there are no more lines
  While lngLineCount < lngLine And rtfTheRtf.SelStart < Len(rtfTheRtf.text) And _
        Not blnEnd
    'Save current position
    rtfTheRtf.SelStart = lngPos
    'Save position of first char of the current line
    lngLineStart = lngPos
    'Select text until end of line
    rtfTheRtf.Span vbCrLf, True, True
    'Span() does not advance the position so we have to do it manually
    rtfTheRtf.UpTo vbCrLf, True, False
    'If position has not moved, there aren't anymore lines
    If rtfTheRtf.SelStart = lngPos Then
      blnEnd = True
    Else
      'Count lines
      lngLineCount = lngLineCount + 1
      'Check if we found the right one
      If lngLineCount = lngLine Then blnFound = True
    End If
     
    'Advance position to the next line (over CRLF)
    lngPos = rtfTheRtf.SelStart + 2
  Wend
   
  'When the line is found then select it
  '(we have to do it again because UpTo() clears the selection)
  If blnFound Then
    'Select the line
    rtfTheRtf.SelStart = lngLineStart
    rtfTheRtf.Span vbCrLf, True, True
  End If
   
  SelectLine = blnFound
End Function
Public Function RandomizeColorFunc()
On Error GoTo 10
Dim CCode%(2)
Dim c%
Randomize
For c% = 0 To 2
 CCode%(c%) = Int(255 * Rnd)
Next
 fMainForm.ActiveForm.rtfText.SelColor = RGB(CCode%(0), CCode%(1), CCode%(2))
10:
End Function
Public Function CustomBox(sPrompt As String, sInfo As String, bStyle As VbMsgBoxStyle, sBt1 As String, sBt2 As String, sBt3 As String) As Integer
Dim i As Integer
With frmDialog
    .cmdButton(2).Caption = sBt1
    .cmdButton(1).Caption = sBt2
    .cmdButton(0).Caption = sBt3
    For i = 0 To 2
        If .cmdButton(i).Caption = "" Then
            .cmdButton(i).Visible = False
        Else
            .cmdButton(i).Visible = True
        End If
    Next
    Select Case bStyle
    Case vbCritical
        i = 3
    Case vbExclamation
        i = 2
    Case vbInformation
        i = 1
    Case Else
        i = 1
    End Select
    .imgIcon.Picture = .imgList.ListImages(i).Picture
    .imgIcon.Left = 24 * Screen.TwipsPerPixelX
    .imgIcon.Top = 15 * Screen.TwipsPerPixelY
    .lblMsg.Top = 15 * Screen.TwipsPerPixelY
    .lblMsg.Left = .imgIcon.Left + .imgIcon.Width + (16 * Screen.TwipsPerPixelX)
    .lblMsg.Width = .Width - .lblMsg.Left - (24 * Screen.TwipsPerPixelX)
    .lblInfo.Left = .lblMsg.Left
    .lblInfo.Width = .lblMsg.Width
    .lblInfo.Top = .lblMsg.Top + .lblMsg.Height + (8 * Screen.TwipsPerPixelY)
    .cmdButton(0).Left = (.Width - 24 * Screen.TwipsPerPixelX) - .cmdButton(0).Width
    .cmdButton(1).Left = .cmdButton(0).Left - (12 * Screen.TwipsPerPixelX) - .cmdButton(1).Width
    .cmdButton(2).Left = .lblInfo.Left
    .lblMsg.Caption = sPrompt
    .lblInfo.Caption = sInfo
    .Show vbModal
End With
CustomBox = intMsgReturn
End Function
Public Function ParseFileName(sFileIn As String) As String
Dim i As Integer
   For i = Len(sFileIn) To 1 Step -1
      If InStr("\", Mid$(sFileIn, i, 1)) Then Exit For
   Next
   ParseFileName = Mid$(sFileIn, i + 1, Len(sFileIn) - i)
End Function
