Attribute VB_Name = "modHighlight"
        '- - - - - - - - - - - - - - - - - - - - - - - - - - - - '
        ' Hyperwrite from NIXON                                  '
        ' Copyright (C) 2004-2006 NIXON Software Corporation.    '
        '- - - - - - - - - - - - - - - - - - - - - - - - - - - - '
        ' You may use this code freely in your own applications. '
        ' If you are distributing your code/application(s), it   '
        ' would be greatly appreciated if you credit NIXON in    '
        ' your About dialog. Please note that portions of this   '
        ' code belongs to other people. For more details, please '
        ' view the About dialog.                                 '
        '- - - - - - - - - - - - - - - - - - - - - - - - - - - - '
        ' This module is from Bobo's RTF Tricks.                 '
        '- - - - - - - - - - - - - - - - - - - - - - - - - - - - '
Option Explicit

Public Const LF_FACESIZE = 32
Public Const WM_USER = &H400
Public Const EM_SETCHARFORMAT = (WM_USER + 68)
Public Const CFM_BACKCOLOR = &H4000000
Public Const SCF_SELECTION = &H1
Private Const EM_SCROLL = &HB5
Private Const EM_GETFIRSTVISIBLELINE = &HCE
Dim ColorColl As Collection
Public Type CHARFORMAT2
    cbSize As Integer    '2
    wPad1 As Integer    '4
    dwMask As Long    '8
    dwEffects As Long    '12
    yHeight As Long    '16
    yOffset As Long    '20
    crTextColor As Long    '24
    bCharSet As Byte    '25
    bPitchAndFamily As Byte    '26
    szFaceName(0 To LF_FACESIZE - 1) As Byte    ' 58
    wPad2 As Integer    ' 60

' Additional stuff supported by RICHEDIT20
    wWeight As Integer    ' /* Font weight (LOGFONT value)      */
    sSpacing As Integer    ' /* Amount to space between letters  */
    crBackColor As Long    ' /* Background color                 */
    lLCID As Long    ' /* Locale ID                        */
    dwReserved As Long    ' /* Reserved. Must be 0              */
    sStyle As Integer    ' /* Style handle                     */
    wKerning As Integer    ' /* Twip size above which to kern char pair*/
    bUnderlineType As Byte    ' /* Underline type                   */
    bAnimation As Byte    ' /* Animated text like marching ants */
    bRevAuthor As Byte    ' /* Revision author index            */
    bReserved1 As Byte
End Type
Private Sub GetColorTable(mRTF As RichTextBox)
    Dim z As Long, z1 As Long, temp As String, tmp() As String, tmpCol() As String
    Set ColorColl = New Collection
    ColorColl.Add 0
    'Parse the RTF code to extract the Colortable
    z = InStr(1, mRTF.TextRTF, "{\colortbl")
    If z = 0 Then
        Exit Sub
    Else
        'Parse the Colortable to extract the colors used
        z1 = InStr(z, mRTF.TextRTF, "}")
        If z1 = 0 Then
            Exit Sub
        Else
            temp = Mid(mRTF.TextRTF, z, z1 - z + 1)
            tmp = Split(temp, ";")
            For z = 1 To UBound(tmp) - 1
                If tmp(z) <> "" Then
                    If Left(tmp(z), 1) = "\" Then tmp(z) = Right(tmp(z), Len(tmp(z)) - 1)
                    tmpCol = Split(tmp(z), "\")
                    'Dump the colors found into a collection
                    ColorColl.Add RGB(Val(Right(tmpCol(0), Len(tmpCol(0)) - 3)), Val(Right(tmpCol(1), Len(tmpCol(1)) - 5)), Val(Right(tmpCol(2), Len(tmpCol(2)) - 4)))
                End If
            Next
        End If
    End If
End Sub
Public Sub SetScrollPos(mForm As Form, mRTF As RichTextBox, mPos As Long, Optional DontLock As Boolean)
    Dim CurLineCount As Long, curvl As Long, lastvl As Long
    'how many lines?
    CurLineCount = SendMessage(mRTF.hwnd, EM_GETLINECOUNT, ByVal 0&, ByVal 0&)
    'what's the current top line?
    curvl = SendMessage(mRTF.hwnd, EM_GETFIRSTVISIBLELINE, ByVal 0&, ByVal 0&)
    If Not DontLock Then LockWindowUpdate mForm.hwnd
    'use a "PageUp" or "PageDown" for a few big jumps to get close to our target line
    If mPos < curvl Then
        Do Until curvl < mPos
            SendMessage mRTF.hwnd, EM_SCROLL, 2, 0
            curvl = SendMessage(mRTF.hwnd, EM_GETFIRSTVISIBLELINE, ByVal 0&, ByVal 0&)
            If curvl = 0 Or curvl = CurLineCount Then Exit Do
        Loop
    Else
        Do Until curvl > mPos
            SendMessage mRTF.hwnd, EM_SCROLL, 3, 0
            curvl = SendMessage(mRTF.hwnd, EM_GETFIRSTVISIBLELINE, ByVal 0&, ByVal 0&)
            If curvl = 0 Or curvl = CurLineCount Or lastvl = curvl Then Exit Do
            lastvl = curvl
        Loop
    End If
    'Now do some fine adjustment line by line to get
    'it exactly right
    Do Until curvl = mPos
        If mPos < curvl Then
            SendMessage mRTF.hwnd, EM_SCROLL, 0, 0
        Else
            SendMessage mRTF.hwnd, EM_SCROLL, 1, 0
        End If
        curvl = SendMessage(mRTF.hwnd, EM_GETFIRSTVISIBLELINE, ByVal 0&, ByVal 0&)
        If curvl = 0 Or curvl = CurLineCount Or lastvl = curvl Then
            If curvl = 0 Then SendMessage mRTF.hwnd, EM_SCROLL, 0, 0
            Exit Do
        End If
        lastvl = curvl
    Loop
    If Not DontLock Then LockWindowUpdate 0
End Sub
